'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Public Class Form1

#Region "Variables"
    Private randomInts As Integer() = Nothing
    Private nodeCount As Integer = 0
#End Region

#Region "Initialization"
    Public Sub New()
        InitializeComponent()

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r""><p>In this sample we are demonstrating how to expand nodes by clicking on hyperlink inside node space.</p><br></br>"
        content += "<p>There are 3 cases presented:<br></br>"
        content += "   1. Whole node is a hyperlink<br></br>"
        content += "   2. Node contains hyperlinks inside its content<br></br>"
        content += "   3. Node contains a hyperlink aligned on right side</p><br></br>"
        content += "<p>In each case you can expand or collapse nodes, except in second case where node is expanded from first hyperlink and collapsed from the second.</p>"
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub InitList()
        Me.treeView1.SuspendUpdate()

        nodeCount = 0
        randomInts = CreateRandomInts()

        CreateNode(Me.treeView1.RootNode, "", 0)

        Me.treeView1.ResumeUpdate()
    End Sub

    Private Sub CreateNode(ByVal parentNode As LidorSystems.IntegralUI.Lists.TreeNode, ByVal prefix As [String], ByVal level As Integer)
        If level = 5 Then
            Return
        End If

        Dim limit As Integer = randomInts(nodeCount Mod 99)
        If level = 0 Then
            limit = 25
        End If

        Dim node As LidorSystems.IntegralUI.Lists.TreeNode = Nothing
        For i As Integer = 1 To limit
            node = New LidorSystems.IntegralUI.Lists.TreeNode("Node " & Convert.ToString(prefix) & i.ToString())
            node.Key = node.Text
            nodeCount += 1

            CreateNode(node, Convert.ToString(prefix) & i.ToString(), level + 1)

            If node.Nodes.Count > 0 Then
                Select Case nodeCount Mod 7
                    Case 2
                        ' A node with multuple hyperlinks
                        node.Content = (("<div>" + node.Text & " - Multiple hyperlinks: one will <a href=""Expand"" id=""") + node.Key & """ style=""hovertextcolor:Blue"">Expand</a> and the other will <a href=""Collapse"" id=""") + node.Key & """ style=""hovertextcolor:Blue"">Collapse</a></div>"
                        Exit Select
                    Case 4
                        ' Node with a hyperlink aligned to the right side
                        node.Content = ("<div><table width=""100%""><tr><td width=""100%"">" + node.Text & "</td><td style=""hovertextcolor:Red""><a href=""Toggle"" id=""") + node.Key & """>Toggle</a></td></tr></table></div>"
                        Exit Select
                    Case 1, 6
                        ' Whole node is a hyperlink
                        node.Content = (("<div><a href=""" + node.Text & """ id=""") + node.Key & """ style=""hovertextcolor:Green"">") + node.Text & " - Click to Expand and Collapse the node</a></div>"
                        Exit Select
                End Select
            End If


            parentNode.Nodes.Add(node)
        Next
    End Sub

    Private Function CreateRandomInts() As Integer()
        Dim rand As Integer() = New Integer(99) {}
        Dim gen As New Random()
        For i As Integer = 0 To rand.Length - 1
            rand(i) = gen.[Next](0, 5)
        Next

        Return rand
    End Function
#End Region

#Region "Hyperlink Events"
    Private Sub treeView1_ItemObjectClicked(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectClickEventArgs) Handles treeView1.ItemObjectClicked
        ' Hyperlinks in node are converted to standard LinkLabel control
        ' Check whether the object within the event is of type LinkLabel
        If TypeOf e.[Object] Is LinkLabel Then
            Dim lLabel As LinkLabel = DirectCast(e.[Object], LinkLabel)
            Dim action As [String] = lLabel.Links(0).LinkData.ToString()

            ' Determine which node's hyperlink is clicked using the KEY carried with the event
            ' If a node is found, expand or collapse it
            Dim node As LidorSystems.IntegralUI.Lists.TreeNode = Me.treeView1.FindNode(e.Key, LidorSystems.IntegralUI.Lists.ListSearchCriteria.byKey)
            If node IsNot Nothing Then
                Select Case action
                    Case "Expand"
                        node.Expand()
                        Exit Select

                    Case "Collapse"
                        node.Collapse()
                        Exit Select
                    Case Else

                        node.Toggle()
                        Exit Select
                End Select
            End If
        End If
    End Sub
#End Region

End Class
